"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Lokale = (function () {
    function Lokale(storage) {
        var _this = this;
        this.isSupported = false;
        this.lokaleStorage = storage || localStorage;
        this.isSupported = (function () {
            try {
                var dummyKey = "IamHereToCheckOnYou";
                _this.lokaleStorage.setItem(dummyKey, dummyKey);
                _this.lokaleStorage.removeItem(dummyKey);
                return true;
            }
            catch (_a) {
                return false;
            }
        })();
    }
    Lokale.prototype.getItem = function (key) {
        if (this.isSupported) {
            return localStorage.getItem(key);
        }
        return null;
    };
    Lokale.prototype.hasItem = function (key) {
        if (this.isSupported) {
            return localStorage.getItem(key) !== null;
        }
        return false;
    };
    Lokale.prototype.setItem = function (key, value) {
        if (this.isSupported) {
            return this.lokaleStorage.setItem(key, value);
        }
    };
    Lokale.prototype.removeItem = function (key) {
        if (this.isSupported) {
            if (this.lokaleStorage.hasOwnProperty(key)) {
                return this.lokaleStorage.removeItem(key);
            }
        }
    };
    Lokale.prototype.clear = function () {
        if (this.isSupported) {
            this.lokaleStorage.clear();
        }
    };
    Lokale.prototype.getSpaceUsage = function () {
        var _this = this;
        var result = {
            availableSpace: "",
            usedSpace: "",
        };
        var usedSpace = 0;
        var hasSpace = true;
        var dummyData = "A";
        if (this.isSupported) {
            while (hasSpace) {
                try {
                    dummyData += dummyData;
                    this.lokaleStorage.setItem("availableSpace", dummyData);
                }
                catch (e) {
                    hasSpace = false;
                }
            }
            Object.keys(this.lokaleStorage).forEach(function (key) {
                var amount = (_this.lokaleStorage[key].length * 2) / 1024 / 1024;
                usedSpace += amount;
                result[key] = amount.toFixed(2) + " MB";
            });
            result.usedSpace = usedSpace.toFixed(2) + " MB";
            result.availableSpace = usedSpace.toFixed(2) + " MB";
            this.lokaleStorage.removeItem("availableSpace");
        }
        return result;
    };
    return Lokale;
}());
exports.default = Lokale;
